#ifndef HELPERFUNCTION_HPP
#define HELPERFUNCTION_HPP

#include <sys/stat.h> // use to create a directory in ubuntu system

#include <cmath>
#include <vector>
#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <fstream>

class HelperFunction
{
    public:
        HelperFunction();

        double Contraction (std::vector< std::vector<double> > & A,
                            std::vector< std::vector<double> > & B );
        std::vector< std::vector<double> > Dyadic (std::vector<double> & A,
                                                   std::vector<double> & B );

        std::vector< std::vector<double> > Add (std::vector< std::vector<double> > & A,
                                                std::vector< std::vector<double> > & B );
        std::vector< std::vector<double> > Add (std::vector< std::vector<double> > & A,
                                                std::vector< std::vector<double> > & B,
                                                std::vector< std::vector<double> > & C );
        std::vector< std::vector<double> > Add (std::vector< std::vector<double> > & A,
                                                std::vector< std::vector<double> > & B,
                                                std::vector< std::vector<double> > & C,
                                                std::vector< std::vector<double> > & D );
        std::vector<double> Add (std::vector<double> & A, std::vector<double> & B );
        std::vector<double> Add (std::vector<double> & A, std::vector<double> & B, std::vector<double> & C );

        std::vector< std::vector<double> > Subtract (std::vector< std::vector<double> > & A,
                                                        std::vector< std::vector<double> > & B );
        std::vector<double> Subtract (std::vector<double> & A, std::vector<double> & B );

        std::vector< std::vector<double> > Multiply (std::vector< std::vector<double> > & A,
                                                std::vector< std::vector<double> > & B );
        std::vector< std::vector<double> > Multiply (std::vector< std::vector<double> > & A,
                                                std::vector< std::vector<double> > & B,
                                                std::vector< std::vector<double> > & C );
        std::vector< std::vector<double> > Multiply ( double A, std::vector< std::vector<double> > & B );

        double Determinant ( std::vector< std::vector<double> > & A );
        std::vector< std::vector<double> > Inverse ( std::vector< std::vector<double> > & A );
        std::vector< std::vector<double> > Identity ( double A );
        std::vector< std::vector<double> > ZeroTensor ( double A );
        double Trace ( std::vector< std::vector<double> > & A );
        std::vector< std::vector<double> > Transpose ( std::vector< std::vector<double> > & A );
        std::vector< std::vector<double> > DeviatoricPartofTensor ( std::vector< std::vector<double> > & A );

        void PrintTensor(std::vector< std::vector<double> > & A);
        void PrintTensor(std::vector< double > & A);

        long double Factorial(int A);

        double GetExponentialIntegralValue(double A);


        void LUDecomposition(std::vector< std::vector<double> > & A,
                            std::vector< std::vector<double> > & LowerT,
                            std::vector< std::vector<double> > & UpperT);// Does a LU decomposition
        std::vector<double> SolveLinearEquations(std::vector< std::vector<double> > & A,
                                                    std::vector<double> & B);// Solve Ax = b


    protected:
    private:

};

#endif // HELPERFUNCTION_HPP
